Class | ActiveSupport::Multibyte::Chars
In: | lib/active_support/multibyte/chars.rb
Parent: | Object

Chars enables you to work transparently with multibyte encodings in the Ruby String class without having extensive knowledge about the encoding. A Chars object accepts a string upon initialization and proxies String methods in an encoding safe manner. All the normal String methods are also implemented on the proxy.

String methods are proxied through the Chars object, and can be accessed through the `chars` method. Methods which would normally return a String object now return a Chars object so methods can be chained.

      "The Perfect String  ".chars.downcase.strip.normalize # => "the perfect string"

Chars objects are perfectly interchangeable with String objects as long as no explicit class checks are made. If certain methods do explicitly check the class, call `to_s` before you pass chars objects to them.

      bad.explicit_checking_method "T".chars.downcase.to_s

The actual operations on the string are delegated to handlers. Theoretically handlers can be implemented for any encoding, but the default handler handles UTF-8. This handler is set during initialization, if you want to use you own handler, you can set it on the Chars class. Look at the UTF8Handler source for an example how to implement your own handler. If you your own handler to work on anything but UTF-8 you probably also want to override Chars#handler.

      ActiveSupport::Multibyte::Chars.handler = MyHandler

Note that a few methods are defined on Chars instead of the handler because they are defined on Object or Kernel and method_missing can‘t catch them.

### Methods

<=> =~ gsub handler handler= method_missing new respond_to? split to_str

### Included Modules

Comparable

### External Aliases

string | -> | to_s

### Attributes

string | [R] |

### Public Class methods

handler=(klass)

Set the handler class for the Char objects.

new(str)

Create a new Chars instance.

### Public Instance methods

<=>(other)

Returns -1, 0 or +1 depending on whether the Chars object is to be sorted before, equal or after the object on the right side of the operation. It accepts any object that implements `to_s`. See String.<=> for more details.

=~(other)

Like String.=~ only it returns the character offset (in codepoints) instead of the byte offset.

gsub(*a, &b)

Gsub works exactly the same as gsub on a normal string.

handler()

Returns the proper handler for the contained string depending on $KCODE and the encoding of the string. This method is used internally to always redirect messages to the proper classes depending on the context.

method_missing(m, *a, &b)

Try to forward all undefined methods to the handler, when a method is not defined on the handler, send it to the contained string. Method_missing is also responsible for making the bang! methods destructive.

respond_to?(method, include_priv = false)

Make duck-typing with String possible

split(*args)

Works just like String#split, with the exception that the items in the resulting list are Chars instances instead of String. This makes chaining methods easier.

to_str()

The magic method to make String and Chars comparable

[Validate]